/*
 * This file was generated by the CommonAPI Generators.
 * Used org.genivi.commonapi.someip 3.2.0.v202012010944.
 * Used org.franca.core 0.13.1.201807231814.
 *
 * This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0.
 * If a copy of the MPL was not distributed with this file, You can obtain one at
 * http://mozilla.org/MPL/2.0/.
 */
#ifndef V0_COMMONAPI_DEMO_DEMO_APP1_SOMEIP_STUB_ADAPTER_HPP_
#define V0_COMMONAPI_DEMO_DEMO_APP1_SOMEIP_STUB_ADAPTER_HPP_

#include <v0/commonapi/demo/DemoApp1Stub.hpp>
#include <v0/commonapi/demo/DemoApp1SomeIPDeployment.hpp>
#include <v0/commonapi/demo/CommonTypesSomeIPDeployment.hpp>

#if !defined (COMMONAPI_INTERNAL_COMPILATION)
#define COMMONAPI_INTERNAL_COMPILATION
#define HAS_DEFINED_COMMONAPI_INTERNAL_COMPILATION_HERE
#endif

#include <CommonAPI/SomeIP/AddressTranslator.hpp>
#include <CommonAPI/SomeIP/StubAdapterHelper.hpp>
#include <CommonAPI/SomeIP/StubAdapter.hpp>
#include <CommonAPI/SomeIP/Factory.hpp>
#include <CommonAPI/SomeIP/Types.hpp>
#include <CommonAPI/SomeIP/Constants.hpp>

#if defined (HAS_DEFINED_COMMONAPI_INTERNAL_COMPILATION_HERE)
#undef COMMONAPI_INTERNAL_COMPILATION
#undef HAS_DEFINED_COMMONAPI_INTERNAL_COMPILATION_HERE
#endif

namespace v0 {
namespace commonapi {
namespace demo {

template <typename _Stub = ::v0::commonapi::demo::DemoApp1Stub, typename... _Stubs>
class DemoApp1SomeIPStubAdapterInternal
    : public virtual DemoApp1StubAdapter,
      public CommonAPI::SomeIP::StubAdapterHelper< _Stub, _Stubs...>,
      public std::enable_shared_from_this< DemoApp1SomeIPStubAdapterInternal<_Stub, _Stubs...>>
{
public:
    typedef CommonAPI::SomeIP::StubAdapterHelper< _Stub, _Stubs...> DemoApp1SomeIPStubAdapterHelper;

    ~DemoApp1SomeIPStubAdapterInternal() {
        deactivateManagedInstances();
        DemoApp1SomeIPStubAdapterHelper::deinit();
    }

    void fireUiDemoAttr1AttributeChanged(const int32_t &_value);
    
    void fireA1DemoAttributeChanged(const ::v0::commonapi::demo::CommonTypes::a1Struct &_value);
    
    void fireDemoStatus1Event(const int32_t &_uiValue);

    void fireDemoStatus2Event();

    void deactivateManagedInstances() {}
    
    CommonAPI::SomeIP::GetAttributeStubDispatcher<
        ::v0::commonapi::demo::DemoApp1Stub,
        CommonAPI::Version
    > getDemoApp1InterfaceVersionStubDispatcher;

    CommonAPI::SomeIP::GetAttributeStubDispatcher<
        ::v0::commonapi::demo::DemoApp1Stub,
        int32_t,
        CommonAPI::SomeIP::IntegerDeployment<int32_t>
    > getUiDemoAttr1AttributeStubDispatcher;
    
    CommonAPI::SomeIP::SetObservableAttributeStubDispatcher<
        ::v0::commonapi::demo::DemoApp1Stub,
        int32_t,
        CommonAPI::SomeIP::IntegerDeployment<int32_t>
    > setUiDemoAttr1AttributeStubDispatcher;
    
    CommonAPI::SomeIP::GetAttributeStubDispatcher<
        ::v0::commonapi::demo::DemoApp1Stub,
        ::v0::commonapi::demo::CommonTypes::a1Struct,
        ::v0::commonapi::demo::CommonTypes_::a1StructDeployment_t
    > getA1DemoAttributeStubDispatcher;
    
    CommonAPI::SomeIP::SetObservableAttributeStubDispatcher<
        ::v0::commonapi::demo::DemoApp1Stub,
        ::v0::commonapi::demo::CommonTypes::a1Struct,
        ::v0::commonapi::demo::CommonTypes_::a1StructDeployment_t
    > setA1DemoAttributeStubDispatcher;
    
    CommonAPI::SomeIP::MethodWithReplyStubDispatcher<
        ::v0::commonapi::demo::DemoApp1Stub,
        std::tuple< std::string>,
        std::tuple< std::string>,
        std::tuple< CommonAPI::SomeIP::StringDeployment>,
        std::tuple< CommonAPI::SomeIP::StringDeployment>
    > demoMethod1StubDispatcher;
    
    CommonAPI::SomeIP::MethodWithReplyStubDispatcher<
        ::v0::commonapi::demo::DemoApp1Stub,
        std::tuple< std::string>,
        std::tuple< DemoApp1::stdErrorTypeEnum, std::string>,
        std::tuple< CommonAPI::SomeIP::StringDeployment>,
        std::tuple< ::v0::commonapi::demo::DemoApp1_::stdErrorTypeEnumDeployment_t, CommonAPI::SomeIP::StringDeployment>
    > demoMethodErr1StubDispatcher;
    
    CommonAPI::SomeIP::MethodWithReplyStubDispatcher<
        ::v0::commonapi::demo::DemoApp1Stub,
        std::tuple< std::string, std::vector< int32_t >>,
        std::tuple< std::string>,
        std::tuple< CommonAPI::SomeIP::StringDeployment, CommonAPI::SomeIP::ArrayDeployment< CommonAPI::SomeIP::IntegerDeployment<int32_t> >>,
        std::tuple< CommonAPI::SomeIP::StringDeployment>
    > demoMethodTp1StubDispatcher;
    
    DemoApp1SomeIPStubAdapterInternal(
        const CommonAPI::SomeIP::Address &_address,
        const std::shared_ptr<CommonAPI::SomeIP::ProxyConnection> &_connection,
        const std::shared_ptr<CommonAPI::StubBase> &_stub):
        CommonAPI::SomeIP::StubAdapter(_address, _connection),
        DemoApp1SomeIPStubAdapterHelper(
            _address,
            _connection,
            std::dynamic_pointer_cast< DemoApp1Stub>(_stub)),
        getDemoApp1InterfaceVersionStubDispatcher(&DemoApp1Stub::lockInterfaceVersionAttribute, &DemoApp1Stub::getInterfaceVersion, false, true),
        getUiDemoAttr1AttributeStubDispatcher(
            &::v0::commonapi::demo::DemoApp1Stub::lockUiDemoAttr1Attribute,
            &::v0::commonapi::demo::DemoApp1Stub::getUiDemoAttr1Attribute,
            false,
            _stub->hasElement(5)),
        setUiDemoAttr1AttributeStubDispatcher(
            &::v0::commonapi::demo::DemoApp1Stub::lockUiDemoAttr1Attribute,
            &::v0::commonapi::demo::DemoApp1Stub::getUiDemoAttr1Attribute,
            &DemoApp1StubRemoteEvent::onRemoteSetUiDemoAttr1Attribute,
            &DemoApp1StubRemoteEvent::onRemoteUiDemoAttr1AttributeChanged,
            &DemoApp1StubAdapter::fireUiDemoAttr1AttributeChanged,
            false,
            _stub->hasElement(5))
        ,
        getA1DemoAttributeStubDispatcher(
            &::v0::commonapi::demo::DemoApp1Stub::lockA1DemoAttribute,
            &::v0::commonapi::demo::DemoApp1Stub::getA1DemoAttribute,
            false,
            _stub->hasElement(6)),
        setA1DemoAttributeStubDispatcher(
            &::v0::commonapi::demo::DemoApp1Stub::lockA1DemoAttribute,
            &::v0::commonapi::demo::DemoApp1Stub::getA1DemoAttribute,
            &DemoApp1StubRemoteEvent::onRemoteSetA1DemoAttribute,
            &DemoApp1StubRemoteEvent::onRemoteA1DemoAttributeChanged,
            &DemoApp1StubAdapter::fireA1DemoAttributeChanged,
            false,
            _stub->hasElement(6))
        ,
        demoMethod1StubDispatcher(
            &DemoApp1Stub::DemoMethod1,
            false,
            _stub->hasElement(0),
            std::make_tuple(&::v0::commonapi::demo::DemoApp1_::DemoMethod1_nameDeployment),
            std::make_tuple(&::v0::commonapi::demo::DemoApp1_::DemoMethod1_messageDeployment))
        
        ,
        demoMethodErr1StubDispatcher(
            &DemoApp1Stub::DemoMethodErr1,
            false,
            _stub->hasElement(1),
            std::make_tuple(&::v0::commonapi::demo::DemoApp1_::DemoMethodErr1_nameDeployment),
            std::make_tuple(static_cast< ::v0::commonapi::demo::DemoApp1_::stdErrorTypeEnumDeployment_t * >(nullptr), &::v0::commonapi::demo::DemoApp1_::DemoMethodErr1_messageDeployment))
        
        ,
        demoMethodTp1StubDispatcher(
            &DemoApp1Stub::DemoMethodTp1,
            false,
            _stub->hasElement(2),
            std::make_tuple(&::v0::commonapi::demo::DemoApp1_::DemoMethodTp1_nameDeployment, static_cast< CommonAPI::SomeIP::ArrayDeployment< CommonAPI::SomeIP::IntegerDeployment<int32_t> >* >(nullptr)),
            std::make_tuple(static_cast< CommonAPI::SomeIP::StringDeployment* >(nullptr)))
        
    {
        DemoApp1SomeIPStubAdapterHelper::addStubDispatcher( { CommonAPI::SomeIP::method_id_t(0xbbb) }, &getUiDemoAttr1AttributeStubDispatcher );
        DemoApp1SomeIPStubAdapterHelper::addStubDispatcher( { CommonAPI::SomeIP::method_id_t(0xbbc) }, &setUiDemoAttr1AttributeStubDispatcher );
        DemoApp1SomeIPStubAdapterHelper::addStubDispatcher( { CommonAPI::SomeIP::method_id_t(0xbbd) }, &getA1DemoAttributeStubDispatcher );
        DemoApp1SomeIPStubAdapterHelper::addStubDispatcher( { CommonAPI::SomeIP::method_id_t(0xbbe) }, &setA1DemoAttributeStubDispatcher );
        DemoApp1SomeIPStubAdapterHelper::addStubDispatcher( { CommonAPI::SomeIP::method_id_t(0x7530) }, &demoMethod1StubDispatcher );
        DemoApp1SomeIPStubAdapterHelper::addStubDispatcher( { CommonAPI::SomeIP::method_id_t(0x7531) }, &demoMethodErr1StubDispatcher );
        DemoApp1SomeIPStubAdapterHelper::addStubDispatcher( { CommonAPI::SomeIP::method_id_t(0x7532) }, &demoMethodTp1StubDispatcher );
        std::shared_ptr<CommonAPI::SomeIP::ClientId> itsClient = std::make_shared<CommonAPI::SomeIP::ClientId>(0xFFFF, 0xFFFFFFFF, 0xFFFFFFFF);

        // Provided events/fields
        {
            std::set<CommonAPI::SomeIP::eventgroup_id_t> itsEventGroups;
            itsEventGroups.insert(CommonAPI::SomeIP::eventgroup_id_t(0x1b58));
            CommonAPI::SomeIP::StubAdapter::registerEvent(CommonAPI::SomeIP::event_id_t(0x80f2), itsEventGroups, CommonAPI::SomeIP::event_type_e::ET_EVENT, CommonAPI::SomeIP::reliability_type_e::RT_UNRELIABLE);
        }
        {
            std::set<CommonAPI::SomeIP::eventgroup_id_t> itsEventGroups;
            itsEventGroups.insert(CommonAPI::SomeIP::eventgroup_id_t(0x1b59));
            CommonAPI::SomeIP::StubAdapter::registerEvent(CommonAPI::SomeIP::event_id_t(0x80f3), itsEventGroups, CommonAPI::SomeIP::event_type_e::ET_EVENT, CommonAPI::SomeIP::reliability_type_e::RT_UNRELIABLE);
        }
        if (_stub->hasElement(5)) {
            std::set<CommonAPI::SomeIP::eventgroup_id_t> itsEventGroups;
            itsEventGroups.insert(CommonAPI::SomeIP::eventgroup_id_t(CommonAPI::SomeIP::eventgroup_id_t(0x1b5a)));
            CommonAPI::SomeIP::StubAdapter::registerEvent(CommonAPI::SomeIP::event_id_t(0x80f4), itsEventGroups, CommonAPI::SomeIP::event_type_e::ET_FIELD, CommonAPI::SomeIP::reliability_type_e::RT_UNRELIABLE);
            fireUiDemoAttr1AttributeChanged(std::dynamic_pointer_cast< ::v0::commonapi::demo::DemoApp1Stub>(_stub)->getUiDemoAttr1Attribute(itsClient));
        }

        if (_stub->hasElement(6)) {
            std::set<CommonAPI::SomeIP::eventgroup_id_t> itsEventGroups;
            itsEventGroups.insert(CommonAPI::SomeIP::eventgroup_id_t(CommonAPI::SomeIP::eventgroup_id_t(0x1b5b)));
            CommonAPI::SomeIP::StubAdapter::registerEvent(CommonAPI::SomeIP::event_id_t(0x80f5), itsEventGroups, CommonAPI::SomeIP::event_type_e::ET_FIELD, CommonAPI::SomeIP::reliability_type_e::RT_UNRELIABLE);
            fireA1DemoAttributeChanged(std::dynamic_pointer_cast< ::v0::commonapi::demo::DemoApp1Stub>(_stub)->getA1DemoAttribute(itsClient));
        }

    }

    // Register/Unregister event handlers for selective broadcasts
    void registerSelectiveEventHandlers();
    void unregisterSelectiveEventHandlers();

};

template <typename _Stub, typename... _Stubs>
void DemoApp1SomeIPStubAdapterInternal<_Stub, _Stubs...>::fireUiDemoAttr1AttributeChanged(const int32_t &_value) {
    CommonAPI::Deployable< int32_t, CommonAPI::SomeIP::IntegerDeployment<int32_t>> deployedValue(_value, static_cast< CommonAPI::SomeIP::IntegerDeployment<int32_t>* >(nullptr));
    CommonAPI::SomeIP::StubEventHelper<
        CommonAPI::SomeIP::SerializableArguments<
            CommonAPI::Deployable<
                int32_t,
                CommonAPI::SomeIP::IntegerDeployment<int32_t>
            >
            >
    >::sendEvent(
        *this,
        CommonAPI::SomeIP::event_id_t(0x80f4),
        false,
        deployedValue
    );
}

template <typename _Stub, typename... _Stubs>
void DemoApp1SomeIPStubAdapterInternal<_Stub, _Stubs...>::fireA1DemoAttributeChanged(const ::v0::commonapi::demo::CommonTypes::a1Struct &_value) {
    CommonAPI::Deployable< ::v0::commonapi::demo::CommonTypes::a1Struct, ::v0::commonapi::demo::CommonTypes_::a1StructDeployment_t> deployedValue(_value, static_cast< ::v0::commonapi::demo::CommonTypes_::a1StructDeployment_t* >(nullptr));
    CommonAPI::SomeIP::StubEventHelper<
        CommonAPI::SomeIP::SerializableArguments<
            CommonAPI::Deployable<
                ::v0::commonapi::demo::CommonTypes::a1Struct,
                ::v0::commonapi::demo::CommonTypes_::a1StructDeployment_t
            >
            >
    >::sendEvent(
        *this,
        CommonAPI::SomeIP::event_id_t(0x80f5),
        false,
        deployedValue
    );
}

template <typename _Stub, typename... _Stubs>
void DemoApp1SomeIPStubAdapterInternal<_Stub, _Stubs...>::fireDemoStatus1Event(const int32_t &_uiValue) {
    CommonAPI::Deployable< int32_t, CommonAPI::SomeIP::IntegerDeployment<int32_t>> deployed_uiValue(_uiValue, static_cast< CommonAPI::SomeIP::IntegerDeployment<int32_t>* >(nullptr));
    CommonAPI::SomeIP::StubEventHelper<CommonAPI::SomeIP::SerializableArguments<  CommonAPI::Deployable< int32_t, CommonAPI::SomeIP::IntegerDeployment<int32_t> > 
    >>
        ::sendEvent(
            *this,
            CommonAPI::SomeIP::event_id_t(0x80f2),
            false,
             deployed_uiValue 
    );
}

template <typename _Stub, typename... _Stubs>
void DemoApp1SomeIPStubAdapterInternal<_Stub, _Stubs...>::fireDemoStatus2Event() {
    CommonAPI::SomeIP::StubEventHelper<CommonAPI::SomeIP::SerializableArguments< >>
        ::sendEvent(
            *this,
            CommonAPI::SomeIP::event_id_t(0x80f3),
            false
    );
}


template <typename _Stub, typename... _Stubs>
void DemoApp1SomeIPStubAdapterInternal<_Stub, _Stubs...>::registerSelectiveEventHandlers() {
}

template <typename _Stub, typename... _Stubs>
void DemoApp1SomeIPStubAdapterInternal<_Stub, _Stubs...>::unregisterSelectiveEventHandlers() {
}

template <typename _Stub = ::v0::commonapi::demo::DemoApp1Stub, typename... _Stubs>
class DemoApp1SomeIPStubAdapter
    : public DemoApp1SomeIPStubAdapterInternal<_Stub, _Stubs...> {
public:
    DemoApp1SomeIPStubAdapter(const CommonAPI::SomeIP::Address &_address,
                                            const std::shared_ptr<CommonAPI::SomeIP::ProxyConnection> &_connection,
                                            const std::shared_ptr<CommonAPI::StubBase> &_stub)
        : CommonAPI::SomeIP::StubAdapter(_address, _connection),
          DemoApp1SomeIPStubAdapterInternal<_Stub, _Stubs...>(_address, _connection, _stub) {
    }
};

} // namespace demo
} // namespace commonapi
} // namespace v0

#endif // V0_COMMONAPI_DEMO_Demo_App1_SOMEIP_STUB_ADAPTER_HPP_
